Draft BezCurve: Difference between revisions

From FreeCAD Documentation
(Image originally here)
(More information for the options)
Line 31: Line 31:


<!--T:5-->
<!--T:5-->
* Press {{KEY|F}} or the {{KEY|[[Image:Draft FinishLine.png|12px]] '''[[Draft_FinishLine|Finish]]'''}} button to finish the spline, leaving it open
* Press {{KEY|A}} or the {{Button|[[Image:Draft FinishLine.png|12px]] [[Draft_FinishLine|Finish]]}} button to finish the curve, leaving it open.
* Press {{KEY|C}} or the {{KEY|[[Image:Draft CloseLine.png|12px]] '''[[Draft_CloseLine|Close]]'''}} button or click on the first point to finish the spline, but making it closed by adding a last segment between the last point and the first one.
* Press {{KEY|O}} or the {{Button|[[Image:Draft CloseLine.png|12px]] [[Draft_CloseLine|Close]]}} button to close the curve, that is, a segment will be added from the last point to the first one to form a face. At least four points, a curve of degree three, are required to form a face.
* Press {{KEY|W}} or the {{Button|[[Image:Draft Wipe.svg|12px]] [[Draft_Wipe|Wipe]]}} button to remove the curve segments already placed, but keep editing the curve from the last point.
* Press {{KEY|U}} or the {{Button|[[Image:Draft SelectPlane.svg|12px]] [[Draft_SelectPlane|Set WP]]}} button to adjust the current working plane in the orientation of the last point.
* Press {{KEY|X}}, {{KEY|Y}} or {{KEY|Z}} after a point to constrain the next point on the given axis.
* Press {{KEY|X}}, {{KEY|Y}} or {{KEY|Z}} after a point to constrain the next point on the given axis.
* To enter coordinates manually, simply enter the numbers, then press {{KEY|ENTER}} between each X, Y and Z component.
* To enter coordinates manually, simply enter the numbers, then press {{KEY|Enter}} between each X, Y and Z component.
* Press {{KEY|R}} or click the checkbox to check/uncheck the {{KEY|'''Relative'''}} button. If relative mode is on, the coordinates of the next point are relative to the last one. If not, they are absolute, taken from the (0,0,0) origin point.
* Press {{KEY|R}} or click the checkbox to toggle ''relative'' mode. If relative mode is on, the coordinates of the next point are relative to the last one; if not, they are absolute, taken from the origin (0,0,0).
* Press {{KEY|T}} or click the checkbox to check/uncheck the {{KEY|'''Continue'''}} button. If continue mode is on, the BezCurve tool will restart after you finish or close it, allowing you to draw another one without pressing the BezCurve button again.
* Press {{KEY|T}} or click the checkbox to toggle ''continue'' mode. If continue mode is on, the BezCurve tool will restart after you finish the curve, allowing you to draw another one without pressing the tool button again.
* Press {{KEY|L}} or click the checkbox to toggle ''filled'' mode. If filled mode is on, a closed wire will create a filled face ({{PropertyData|Make Face}} {{TRUE}}); if not, the closed wire will not make a face ({{PropertyData|Make Face}} {{FALSE}}).
* Press {{KEY|CTRL}} while drawing to force [[Draft_Snap|snapping]] your point to the nearest snap location, independently of the distance.
* Press {{KEY|SHIFT}} while drawing to [[Draft_Constrain|constrain]] your next point horizontally or vertically in relation to the last one.
* Press {{KEY|Ctrl}} while drawing to force [[Draft_Snap|snapping]] your point to the nearest snap location, independently of the distance.
* Press {{KEY|W}} or press the {{KEY|[[Image:Draft Wipe.png|12px]] '''Wipe'''}} button to remove the existing segments and start the spline from the last point.
* Press {{KEY|Shift}} while drawing to [[Draft_Constrain|constrain]] your next point horizontally or vertically in relation to the last one.
* Press {{KEY|CTRL}}+{{KEY|Z}} or press the {{KEY|[[Image:Draft UndoLine.png|12px]] '''[[Draft_UndoLine|Undo]]'''}} button to undo the last point.
* Press {{KEY|Ctrl}}+{{KEY|Z}} or press the {{button|[[Image:Draft UndoLine.png|12px]] [[Draft_UndoLine|Undo]]}} button to undo the last point.
* Press {{KEY|ESC}} or the {{KEY|'''Cancel'''}} button to abort the current BezCurve command.
* Press {{KEY|Esc}} or the {{button|Close}} button to abort the current command; curve segments already placed will remain.


==Properties== <!--T:6-->
==Properties== <!--T:6-->

Revision as of 15:33, 9 November 2018

Draft BezCurve

Menu location
Draft → BezCurve
Workbenches
Draft, Arch
Default shortcut
B Z
Introduced in version
0.14
See also
None

Description

The BezCurve tool creates a Bezier Curve, or a piecewise Bezier curve, from several points in the current work plane. It uses the Draft Linestyle set on the Draft Tray.

How to use

  1. Press the Draft BezCurve button, or press B then Z keys.
  2. Click a first point on the 3D view, or type a coordinate and press the add point button.
  3. Click additional points on the 3D view, or type a coordinate and press the add point button.
  4. Press Esc or the Close button, or double-click the last point to complete the edition.

The object is created as a single Bezier Curve of degree number_of_points - 1.

The Bezier curve can be changed to a piecewise curve of a specified degree after creation by changing its properties. Bezier curves can be edited using Draft Edit.

Options

  • Press A or the Finish button to finish the curve, leaving it open.
  • Press O or the Close button to close the curve, that is, a segment will be added from the last point to the first one to form a face. At least four points, a curve of degree three, are required to form a face.
  • Press W or the Wipe button to remove the curve segments already placed, but keep editing the curve from the last point.
  • Press U or the Set WP button to adjust the current working plane in the orientation of the last point.
  • Press X, Y or Z after a point to constrain the next point on the given axis.
  • To enter coordinates manually, simply enter the numbers, then press Enter between each X, Y and Z component.
  • Press R or click the checkbox to toggle relative mode. If relative mode is on, the coordinates of the next point are relative to the last one; if not, they are absolute, taken from the origin (0,0,0).
  • Press T or click the checkbox to toggle continue mode. If continue mode is on, the BezCurve tool will restart after you finish the curve, allowing you to draw another one without pressing the tool button again.
  • Press L or click the checkbox to toggle filled mode. If filled mode is on, a closed wire will create a filled face (DataMake Face true); if not, the closed wire will not make a face (DataMake Face false).
  • Press Ctrl while drawing to force snapping your point to the nearest snap location, independently of the distance.
  • Press Shift while drawing to constrain your next point horizontally or vertically in relation to the last one.
  • Press Ctrl+Z or press the Undo button to undo the last point.
  • Press Esc or the Close button to abort the current command; curve segments already placed will remain.

Properties

  • DataClosed: Specifies if the Bezier Curve is closed or not
  • DataDegree: Specifies the degree of the Bezier Curve (or segments)

Scripting

The BezCurve tool can by used in macros and from the python console by using the following function:

makeBezCurve(pointslist,[closed],[placement],[support],[degree])
  • Create a Bezier Curve object from the given list of vectors. Instead of a pointslist, you can also pass a Part Wire.

Example:

import FreeCAD,Draft
myFeature = Draft.makeBezCurve(Draft.makeBezCurve(points,False)

Contraining Nodes

The segment endpoints in a piecewise Bezier Curve can be constrained such that adjacent control points are tangent or symmetric to the segments at the endpoint. This is done after object creation using Draft Edit.

  • Sharp - remove constraints
  • Tangent - force adjacent control points to be tangent
  • Symmetric - force adjacent control points to be tangent and equi-distant

Limitations

  • This tool is not available before FreeCAD version 0.14
  • The Points Property does not yet appear in the properties list.
  • OpenCascade does not support Bezier Curve with degree > 25. This should not be a problem in practice.